
# ~/.shinit.sh: executed by ash, bash and pdksh for non-login shells.
# No bashisms, zsh'isms, ksh'isms etc. allowed

# Folding used. get folding.el for your emacs here:
# http://www.csd.uu.se/~andersl/emacs.shtml

# Yes, I am pervert: I use both Emacs and Vim.

### Keep it on during debugging:
#echo "~/.shinit.sh"

# {{{ Loading help

# If some file loads this file and you want to prevent it to be loaded
# again, add these lines to that file that loaded this file:

HOME_SHINIT="1"
#export HOME_SHINIT

# }}}
# {{{ Misc

# Paranoia
umask 022

#ulimit -c unlimited

if test -f /usr/xpg4/bin/id
then
    ID_BIN="/usr/xpg4/bin/id"
else
    ID_BIN="id"
fi

# }}}
# {{{ Finlandization or Finlanndisierung

# If localizations disturbs your shell-scripts, add some unset-commands there.

# I am am Finn. I live in Finland. I speak Finnish. Perkele!
# P.S: We use euro currency

# http://en.wikipedia.org/wiki/Finland
# http://www.odci.gov/cia/publications/factbook/geos/fi.html
# http://www.funet.fi/resources/clickable-Suomi.html
# http://dmoz.org/Regional/Europe/Finland/
# http://www.helsinki.fi/~eisaksso/tarja.html
# http://www.godhatesfags.com/finland.html
# http://www.godhatesfags.com/finland.gif

unset LC_ALL 2> /dev/null

# From Debian:
if locale -a | egrep '^fi_FI.utf8$' > /dev/null 2>&1
then
    export LANG="fi_FI.utf8"
    export LC_ADDRESS="fi_FI.utf8"
    export LC_COLLATE="fi_FI.utf8"
    export LC_CTYPE="fi_FI.utf8"
    export LC_IDENTIFICATION="fi_FI.utf8"
    export LC_MEASUREMENT="fi_FI.utf8"
    export LC_MESSAGES="fi_FI.utf8"
    export LC_MONETARY="fi_FI.utf8"
    export LC_NAME="fi_FI.utf8"
    export LC_NUMERIC="fi_FI.utf8"
    export LC_PAPER="fi_FI.utf8"
    export LC_TELEPHONE="fi_FI.utf8"
    export LC_TIME="fi_FI.utf8"
    #export LC_ALL="fi_FI.utf8"

elif locale -a | egrep '^fi_FI.utf8@euro$' > /dev/null 2>&1
then
    export LANG="fi_FI.utf8@euro"
    export LC_ADDRESS="fi_FI.utf8@euro"
    export LC_COLLATE="fi_FI.utf8@euro"
    export LC_CTYPE="fi_FI.utf8@euro"
    export LC_IDENTIFICATION="fi_FI.utf8@euro"
    export LC_MEASUREMENT="fi_FI.utf8@euro"
    export LC_MESSAGES="fi_FI.utf8@euro"
    export LC_MONETARY="fi_FI.utf8@euro"
    export LC_NAME="fi_FI.utf8@euro"
    export LC_NUMERIC="fi_FI.utf8@euro"
    export LC_PAPER="fi_FI.utf8@euro"
    export LC_TELEPHONE="fi_FI.utf8@euro"
    export LC_TIME="fi_FI.utf8@euro"
    #export LC_ALL="fi_FI.utf8@euro"

    # From Sun Solaris
elif locale -a | egrep '^fi_FI.UTF-8$' > /dev/null 2>&1
then
    export LANG="fi_FI.UTF-8"
    export LC_ADDRESS="fi_FI.UTF-8"
    export LC_COLLATE="fi_FI.UTF-8"
    export LC_CTYPE="fi_FI.UTF-8"
    export LC_IDENTIFICATION="fi_FI.UTF-8"
    export LC_MEASUREMENT="fi_FI.UTF-8"
    export LC_MESSAGES="fi_FI.UTF-8"
    export LC_MONETARY="fi_FI.UTF-8"
    export LC_NAME="fi_FI.UTF-8"
    export LC_NUMERIC="fi_FI.UTF-8"
    export LC_PAPER="fi_FI.UTF-8"
    export LC_TELEPHONE="fi_FI.UTF-8"
    export LC_TIME="fi_FI.UTF-8"
    #export LC_ALL="fi_FI.UTF-8"

    # No Finnish Unicode-locale found! Let's try some Finnish ISO-8859-15 -locale:
    # From Debian:
elif locale -a | egrep '^fi_FI.iso885915@euro$' > /dev/null 2>&1
then
    export LANG="fi_FI.iso885915@euro"
    export LC_ADDRESS="fi_FI.iso885915@euro"
    export LC_COLLATE="fi_FI.iso885915@euro"
    export LC_CTYPE="fi_FI.iso885915@euro"
    export LC_IDENTIFICATION="fi_FI.iso885915@euro"
    export LC_MEASUREMENT="fi_FI.iso885915@euro"
    export LC_MESSAGES="fi_FI.iso885915@euro"
    export LC_MONETARY="fi_FI.iso885915@euro"
    export LC_NAME="fi_FI.iso885915@euro"
    export LC_NUMERIC="fi_FI.iso885915@euro"
    export LC_PAPER="fi_FI.iso885915@euro"
    export LC_TELEPHONE="fi_FI.iso885915@euro"
    export LC_TIME="fi_FI.iso885915@euro"
    #export LC_ALL="fi_FI.iso885915@euro"

elif locale -a | egrep '^fi_FI@euro$' > /dev/null 2>&1
then
    export LANG="fi_FI@euro"
    export LC_ADDRESS="fi_FI@euro"
    export LC_COLLATE="fi_FI@euro"
    export LC_CTYPE="fi_FI@euro"
    export LC_IDENTIFICATION="fi_FI@euro"
    export LC_MEASUREMENT="fi_FI@euro"
    export LC_MESSAGES="fi_FI@euro"
    export LC_MONETARY="fi_FI@euro"
    export LC_NAME="fi_FI@euro"
    export LC_NUMERIC="fi_FI@euro"
    export LC_PAPER="fi_FI@euro"
    export LC_TELEPHONE="fi_FI@euro"
    export LC_TIME="fi_FI@euro"
    #export LC_ALL="fi_FI@euro"

    # From Sun Solaris:
elif locale -a | egrep '^fi_FI.ISO8859-15@euro$' > /dev/null 2>&1
then
    export LANG="fi_FI.ISO8859-15@euro"
    export LC_ADDRESS="fi_FI.ISO8859-15@euro"
    export LC_COLLATE="fi_FI.ISO8859-15@euro"
    export LC_CTYPE="fi_FI.ISO8859-15@euro"
    export LC_IDENTIFICATION="fi_FI.ISO8859-15@euro"
    export LC_MEASUREMENT="fi_FI.ISO8859-15@euro"
    export LC_MESSAGES="fi_FI.ISO8859-15@euro"
    export LC_MONETARY="fi_FI.ISO8859-15@euro"
    export LC_NAME="fi_FI.ISO8859-15@euro"
    export LC_NUMERIC="fi_FI.ISO8859-15@euro"
    export LC_PAPER="fi_FI.ISO8859-15@euro"
    export LC_TELEPHONE="fi_FI.ISO8859-15@euro"
    export LC_TIME="fi_FI.ISO8859-15@euro"
    #export LC_ALL="fi_FI.ISO8859-15@euro"

elif locale -a | egrep '^fi_FI.ISO8859-15$' > /dev/null 2>&1
then
    export LANG="fi_FI.ISO8859-15"
    export LC_ADDRESS="fi_FI.ISO8859-15"
    export LC_COLLATE="fi_FI.ISO8859-15"
    export LC_CTYPE="fi_FI.ISO8859-15"
    export LC_IDENTIFICATION="fi_FI.ISO8859-15"
    export LC_MEASUREMENT="fi_FI.ISO8859-15"
    export LC_MESSAGES="fi_FI.ISO8859-15"
    export LC_MONETARY="fi_FI.ISO8859-15"
    export LC_NAME="fi_FI.ISO8859-15"
    export LC_NUMERIC="fi_FI.ISO8859-15"
    export LC_PAPER="fi_FI.ISO8859-15"
    export LC_TELEPHONE="fi_FI.ISO8859-15"
    export LC_TIME="fi_FI.ISO8859-15"
    #export LC_ALL="fi_FI.ISO8859-15"

elif locale -a | egrep '^fi.ISO8859-15$' > /dev/null 2>&1
then
    export LANG="fi.ISO8859-15"
    export LC_ADDRESS="fi.ISO8859-15"
    export LC_COLLATE="fi.ISO8859-15"
    export LC_CTYPE="fi.ISO8859-15"
    export LC_IDENTIFICATION="fi.ISO8859-15"
    export LC_MEASUREMENT="fi.ISO8859-15"
    export LC_MESSAGES="fi.ISO8859-15"
    export LC_MONETARY="fi.ISO8859-15"
    export LC_NAME="fi.ISO8859-15"
    export LC_NUMERIC="fi.ISO8859-15"
    export LC_PAPER="fi.ISO8859-15"
    export LC_TELEPHONE="fi.ISO8859-15"
    export LC_TIME="fi.ISO8859-15"
    #export LC_ALL="fi.ISO8859-15"

    # Let's try some Finnish ISO-8859-1 locales:
    # From Debian:
elif locale -a | egrep '^fi_FI.iso88591$' > /dev/null 2>&1
then
    export LANG="fi_FI.iso88591"
    export LC_ADDRESS="fi_FI.iso88591"
    export LC_COLLATE="fi_FI.iso88591"
    export LC_CTYPE="fi_FI.iso88591"
    export LC_IDENTIFICATION="fi_FI.iso88591"
    export LC_MEASUREMENT="fi_FI.iso88591"
    export LC_MESSAGES="fi_FI.iso88591"
    export LC_MONETARY="fi_FI.iso88591"
    export LC_NAME="fi_FI.iso88591"
    export LC_NUMERIC="fi_FI.iso88591"
    export LC_PAPER="fi_FI.iso88591"
    export LC_TELEPHONE="fi_FI.iso88591"
    export LC_TIME="fi_FI.iso88591"
    #export LC_ALL="fi_FI.iso88591"

    # From Sun Solaris:
elif locale -a | egrep '^fi_FI.ISO8859-1$' > /dev/null 2>&1
then
    export LANG="fi_FI.ISO8859-1"
    export LC_ADDRESS="fi_FI.ISO8859-1"
    export LC_COLLATE="fi_FI.ISO8859-1"
    export LC_CTYPE="fi_FI.ISO8859-1"
    export LC_IDENTIFICATION="fi_FI.ISO8859-1"
    export LC_MEASUREMENT="fi_FI.ISO8859-1"
    export LC_MESSAGES="fi_FI.ISO8859-1"
    export LC_MONETARY="fi_FI.ISO8859-1"
    export LC_NAME="fi_FI.ISO8859-1"
    export LC_NUMERIC="fi_FI.ISO8859-1"
    export LC_PAPER="fi_FI.ISO8859-1"
    export LC_TELEPHONE="fi_FI.ISO8859-1"
    export LC_TIME="fi_FI.ISO8859-1"
    #export LC_ALL="fi_FI.ISO8859-1"

    # Let's try at least some kind of Finnish:
    # From Debian and Sun Solaris:
elif locale -a | egrep '^fi_FI$' > /dev/null 2>&1
then
    export LANG="fi_FI"
    export LC_ADDRESS="fi_FI"
    export LC_COLLATE="fi_FI"
    export LC_CTYPE="fi_FI"
    export LC_IDENTIFICATION="fi_FI"
    export LC_MEASUREMENT="fi_FI"
    export LC_MESSAGES="fi_FI"
    export LC_MONETARY="fi_FI"
    export LC_NAME="fi_FI"
    export LC_NUMERIC="fi_FI"
    export LC_PAPER="fi_FI"
    export LC_TELEPHONE="fi_FI"
    export LC_TIME="fi_FI"
    #export LC_ALL="fi_FI"

    # From Debian
elif locale -a | egrep '^finnish$' > /dev/null 2>&1
then
    export LANG="finnish"
    export LC_ADDRESS="finnish"
    export LC_COLLATE="finnish"
    export LC_CTYPE="finnish"
    export LC_IDENTIFICATION="finnish"
    export LC_MEASUREMENT="finnish"
    export LC_MESSAGES="finnish"
    export LC_MONETARY="finnish"
    export LC_NAME="finnish"
    export LC_NUMERIC="finnish"
    export LC_PAPER="finnish"
    export LC_TELEPHONE="finnish"
    export LC_TIME="finnish"
    #export LC_ALL="finnish"

    # From Sun Solaris
elif locale -a | egrep '^fi$' > /dev/null 2>&1
then
    export LANG="fi"
    export LC_ADDRESS="fi"
    export LC_COLLATE="fi"
    export LC_CTYPE="fi"
    export LC_IDENTIFICATION="fi"
    export LC_MEASUREMENT="fi"
    export LC_MESSAGES="fi"
    export LC_MONETARY="fi"
    export LC_NAME="fi"
    export LC_NUMERIC="fi"
    export LC_PAPER="fi"
    export LC_TELEPHONE="fi"
    export LC_TIME="fi"
    #export LC_ALL="fi"

    # This Unix must be from stone age! Let's try POSIX and C
    # From Debian and Sun Solaris
elif locale -a | egrep '^POSIX$' > /dev/null 2>&1
then
    export LANG="POSIX"
    export LC_ADDRESS="POSIX"
    export LC_COLLATE="POSIX"
    export LC_CTYPE="POSIX"
    export LC_IDENTIFICATION="POSIX"
    export LC_MEASUREMENT="POSIX"
    export LC_MESSAGES="POSIX"
    export LC_MONETARY="POSIX"
    export LC_NAME="POSIX"
    export LC_NUMERIC="POSIX"
    export LC_PAPER="POSIX"
    export LC_TELEPHONE="POSIX"
    export LC_TIME="POSIX"
    #export LC_ALL="POSIX"

elif locale -a | egrep '^C$' > /dev/null 2>&1
then
    export LANG="C"
    export LC_ADDRESS="C"
    export LC_COLLATE="C"
    export LC_CTYPE="C"
    export LC_IDENTIFICATION="C"
    export LC_MEASUREMENT="C"
    export LC_MESSAGES="C"
    export LC_MONETARY="C"
    export LC_NAME="C"
    export LC_NUMERIC="C"
    export LC_PAPER="C"
    export LC_TELEPHONE="C"
    export LC_TIME="C"
    #export LC_ALL="C"

    # From Sun Solaris
elif locale -a | egrep '^common$' > /dev/null 2>&1
then
    export LANG="common"
    export LC_ADDRESS="common"
    export LC_COLLATE="common"
    export LC_CTYPE="common"
    export LC_IDENTIFICATION="common"
    export LC_MEASUREMENT="common"
    export LC_MESSAGES="common"
    export LC_MONETARY="common"
    export LC_NAME="common"
    export LC_NUMERIC="common"
    export LC_PAPER="common"
    export LC_TELEPHONE="common"
    export LC_TIME="common"
    #export LC_ALL="common"


fi

# For ispell

DICTIONARY="finnish.large"
export DICTIONARY

# }}}
# {{{ Environment variables for all shells

export IRCNAME='Juhapekka Tolvanen'
export IRCNICK="naula"
#export IRCSERVER="irc.saunalahti.fi:6667"
#export NNTPSERVER="uutiset.elisa.fi"
export NNTPSERVER="news.individual.net"

export PRINTER="kirjoituksia"

# OOOH.... BABY.... POSIX ME SOOOO HAAARD...
#export POSIXLY_CORRECT="true"
#export POSIX_ME_HARDER="true"

# bc
if test -f "${HOME}/.bcrc"
then
    export BC_ENV_ARGS="${HOME}/.bcrc"
fi

# KDE, Gnome, Qt, Gtk+, Xft and Pango.
export GDK_USE_XFT=1
export GNOME_USE_XALF=1
export GTK2_RC_FILES="${HOME}/.gtkrc-2.0"

# I am Finn. I live in Finland. I speak Finnish.
# I am also fluent in English and I am japanophile, who is learning
# Japanese language:
export PANGO_LANGUAGE="fi;en;ja"

# ### NOTE: Full path is needed nowadays.:
#MYWINDOWMANAGER="/usr/bin/fvwm"
#MYWMRC="${HOME}/.fvwm/.fvwm2rc"
#if test -f ${MYWINDOWMANAGER} -a -f ${MYWMRC}
#then
#    ### See also: http://www.fvwm.org/documentation/faq/#2.8
#
#    ### KDE should obey this:
#    export KDEWM="${MYWINDOWMANAGER}"
#    ### Gnome should obey this:
#    export WINDOW_MANAGER="${MYWINDOWMANAGER}"
#fi

# ONLY FOR DEBUGGING:
#export XFT_DEBUG=1

export MOZ_ENABLE_PANGO=1
export QT_XFT=1
#export XCURSOR_SIZE=48
export XCURSOR_SIZE=64

## SCIM
# A big disadvantage of using GTK IM mode is that it may cause
# mysterious crashes if the GTK+ application (or some module the application
# dynamically loads) is linked to a different version of standard C++ library
# (libstdc++) as SCIM is linked to.
#export GTK_IM_MODULE=scim
#export GTK_IM_MODULE=xim
# WORKS:
#export GTK_IM_MODULE=scim-bridge

#export QT_IM_MODULE=scim
#export QT_IM_MODULE=xim
# WORKS:
#export QT_IM_MODULE=scim-bridge

#export QT_IM_SWITCHER=imsw-multi

#export XIM=SCIM
#export INPUT_METHOD="scim"
# WORKS:
#export XIM_PROGRAM="scim -d"
#export XIM_PROGRAM="scim"
#export XIM_ARGS="-d"
#export XIM_PROGRAM="scim -d -c socket -f x11 -e anthy,socket"
#export XIM_PROGRAM="/usr/bin/skim -d -f"

# WORKS:
# export XMODIFIERS="@im=SCIM"


## Kinput2
#export XMODIFIERS='@im=kinput2'

## UIM
#export XMODIFIERS="@im=uim"
#export GTK_IM_MODULE=uim
#export QT_IM_MODULE=uim
#export UIM_CANDWIN_PROG=uim-candwin-gtk
#export UIM_CANDWIN_PROG=uim-candwin-qt
# WORKS:
#export UIM_FEP=anthy

## IIIMF

#export XMODIFIERS=@im=htt
#export XIM=htt
#export XIM=iiim
#export XIM_PROGRAM=httx
#export XIM_PROGRAM=iiimx
#export XIM_PROGRAM=iiim-xbe
#export GTK_IM_MODULE=iiim
#export QT_IM_MODULE=iiim
#export XMODIFIERS=@im=iiim


# Mule-UCS of emacsen
export DEB_MULEUCS_UNICODE="on"

export OGLE_USE_XV=0

# http://freshmeat.net/articles/view/730/
# Install a Debian-package called "pentium-builder".
export DEBIAN_BUILDARCH="athlon-xp"

#export PERL5LIB="/usr/local/lib/perl5"


# }}}
# {{{ Functions for all shells

# FOR (T)CSH-JUNKIES
# This is from rjl@math.jyu.fi
setenv ()
{
    case "$#" in
        0)
            export ;;
        1)
            export $1 ;;
        2)
            export $1="$2" ;;
        *)
            echo 'setenv: too many arguments' >&2
    esac
}

# Add some directory to PATH if it really exists
# and if it really is directory and if it is not
# yet in PATH
pathmunge ()
{
    if ! echo $PATH | /bin/egrep "(^|:)$1($|:)" > /dev/null 2>&1
    then
        if test -d $1
        then
            if test "$2" = "after"
            then
                PATH=$PATH:$1
            else
                PATH=$1:$PATH
            fi
        fi
    fi
}

# OLD VERSION
#pathmunge ()
#{
#    if ! echo $PATH | /bin/egrep "(^|:)$1($|:)" > /dev/null 2>&1
#    then
#        if test "$2" = "after"
#        then
#            PATH=$PATH:$1
#        else
#            PATH=$1:$PATH
#        fi
#    fi
#}

# }}}
# {{{ Start of path manipulation: Add dirs of /usr/local to the beginning.

pathmunge /usr/local/bin
pathmunge /usr/local/scripts

# }}}
# {{{ Path manipulation and locales for root: Add sbin-dirs to the beginning.

if test "`$ID_BIN -u`" = "0"
then
    pathmunge /usr/sbin/
    pathmunge /sbin
    pathmunge /usr/local/sbin

    unset LC_ALL
    unset LANG

    # Root wants to speak English:
    if locale > /dev/null 2>&1
    then
        # From Debian:
        if locale -a | egrep '^en_GB.utf8$' > /dev/null 2>&1
        then
            export LANG="en_GB.utf8"
            export LC_ADDRESS="en_GB.utf8"
            export LC_COLLATE="en_GB.utf8"
            export LC_CTYPE="en_GB.utf8"
            export LC_IDENTIFICATION="en_GB.utf8"
            export LC_MEASUREMENT="en_GB.utf8"
            export LC_MESSAGES="en_GB.utf8"
            export LC_MONETARY="en_GB.utf8"
            export LC_NAME="en_GB.utf8"
            export LC_NUMERIC="en_GB.utf8"
            export LC_PAPER="en_GB.utf8"
            export LC_TELEPHONE="en_GB.utf8"
            export LC_TIME="en_GB.utf8"
            export LC_ALL="en_GB.utf8"

        elif locale -a | egrep '^en_US.utf8$' > /dev/null 2>&1
        then
            export LANG="en_US.utf8"
            export LC_ADDRESS="en_US.utf8"
            export LC_COLLATE="en_US.utf8"
            export LC_CTYPE="en_US.utf8"
            export LC_IDENTIFICATION="en_US.utf8"
            export LC_MEASUREMENT="en_US.utf8"
            export LC_MESSAGES="en_US.utf8"
            export LC_MONETARY="en_US.utf8"
            export LC_NAME="en_US.utf8"
            export LC_NUMERIC="en_US.utf8"
            export LC_PAPER="en_US.utf8"
            export LC_TELEPHONE="en_US.utf8"
            export LC_TIME="en_US.utf8"
            export LC_ALL="en_US.utf8"

            #From Sun Solaris:
        elif locale -a | egrep '^en_US.UTF-8$' > /dev/null 2>&1
        then
            export LANG="en_US.UTF-8"
            export LC_ADDRESS="en_US.UTF-8"
            export LC_COLLATE="en_US.UTF-8"
            export LC_CTYPE="en_US.UTF-8"
            export LC_IDENTIFICATION="en_US.UTF-8"
            export LC_MEASUREMENT="en_US.UTF-8"
            export LC_MESSAGES="en_US.UTF-8"
            export LC_MONETARY="en_US.UTF-8"
            export LC_NAME="en_US.UTF-8"
            export LC_NUMERIC="en_US.UTF-8"
            export LC_PAPER="en_US.UTF-8"
            export LC_TELEPHONE="en_US.UTF-8"
            export LC_TIME="en_US.UTF-8"
            export LC_ALL="en_US.UTF-8"

        elif locale -a | egrep '^en_GB.ISO8859-15@euro$' > /dev/null 2>&1
        then
            export LANG="en_GB.ISO8859-15@euro"
            export LC_ADDRESS="en_GB.ISO8859-15@euro"
            export LC_COLLATE="en_GB.ISO8859-15@euro"
            export LC_CTYPE="en_GB.ISO8859-15@euro"
            export LC_IDENTIFICATION="en_GB.ISO8859-15@euro"
            export LC_MEASUREMENT="en_GB.ISO8859-15@euro"
            export LC_MESSAGES="en_GB.ISO8859-15@euro"
            export LC_MONETARY="en_GB.ISO8859-15@euro"
            export LC_NAME="en_GB.ISO8859-15@euro"
            export LC_NUMERIC="en_GB.ISO8859-15@euro"
            export LC_PAPER="en_GB.ISO8859-15@euro"
            export LC_TELEPHONE="en_GB.ISO8859-15@euro"
            export LC_TIME="en_GB.ISO8859-15@euro"
            export LC_ALL="en_GB.ISO8859-15@euro"


        elif locale -a | egrep '^en_US.ISO8859-15@euro$' > /dev/null 2>&1
        then
            export LANG="en_US.ISO8859-15@euro"
            export LC_ADDRESS="en_US.ISO8859-15@euro"
            export LC_COLLATE="en_US.ISO8859-15@euro"
            export LC_CTYPE="en_US.ISO8859-15@euro"
            export LC_IDENTIFICATION="en_US.ISO8859-15@euro"
            export LC_MEASUREMENT="en_US.ISO8859-15@euro"
            export LC_MESSAGES="en_US.ISO8859-15@euro"
            export LC_MONETARY="en_US.ISO8859-15@euro"
            export LC_NAME="en_US.ISO8859-15@euro"
            export LC_NUMERIC="en_US.ISO8859-15@euro"
            export LC_PAPER="en_US.ISO8859-15@euro"
            export LC_TELEPHONE="en_US.ISO8859-15@euro"
            export LC_TIME="en_US.ISO8859-15@euro"
            export LC_ALL="en_US.ISO8859-15@euro"

        elif locale -a | egrep '^en_GB.ISO8859-15$' > /dev/null 2>&1
        then
            export LANG="en_GB.ISO8859-15"
            export LC_ADDRESS="en_GB.ISO8859-15"
            export LC_COLLATE="en_GB.ISO8859-15"
            export LC_CTYPE="en_GB.ISO8859-15"
            export LC_IDENTIFICATION="en_GB.ISO8859-15"
            export LC_MEASUREMENT="en_GB.ISO8859-15"
            export LC_MESSAGES="en_GB.ISO8859-15"
            export LC_MONETARY="en_GB.ISO8859-15"
            export LC_NAME="en_GB.ISO8859-15"
            export LC_NUMERIC="en_GB.ISO8859-15"
            export LC_PAPER="en_GB.ISO8859-15"
            export LC_TELEPHONE="en_GB.ISO8859-15"
            export LC_TIME="en_GB.ISO8859-15"
            export LC_ALL="en_GB.ISO8859-15"

        elif locale -a | egrep '^en_US.ISO8859-15$' > /dev/null 2>&1
        then
            export LANG="en_US.ISO8859-15"
            export LC_ADDRESS="en_US.ISO8859-15"
            export LC_COLLATE="en_US.ISO8859-15"
            export LC_CTYPE="en_US.ISO8859-15"
            export LC_IDENTIFICATION="en_US.ISO8859-15"
            export LC_MEASUREMENT="en_US.ISO8859-15"
            export LC_MESSAGES="en_US.ISO8859-15"
            export LC_MONETARY="en_US.ISO8859-15"
            export LC_NAME="en_US.ISO8859-15"
            export LC_NUMERIC="en_US.ISO8859-15"
            export LC_PAPER="en_US.ISO8859-15"
            export LC_TELEPHONE="en_US.ISO8859-15"
            export LC_TIME="en_US.ISO8859-15"
            export LC_ALL="en_US.ISO8859-15"

            # From Debian:
        elif locale -a | egrep '^en_GB.iso88591$' > /dev/null 2>&1
        then
            export LANG="en_GB.iso88591"
            export LC_ADDRESS="en_GB.iso88591"
            export LC_COLLATE="en_GB.iso88591"
            export LC_CTYPE="en_GB.iso88591"
            export LC_IDENTIFICATION="en_GB.iso88591"
            export LC_MEASUREMENT="en_GB.iso88591"
            export LC_MESSAGES="en_GB.iso88591"
            export LC_MONETARY="en_GB.iso88591"
            export LC_NAME="en_GB.iso88591"
            export LC_NUMERIC="en_GB.iso88591"
            export LC_PAPER="en_GB.iso88591"
            export LC_TELEPHONE="en_GB.iso88591"
            export LC_TIME="en_GB.iso88591"
            export LC_ALL="en_GB.iso88591"

        elif locale -a | egrep '^en_US.iso88591$' > /dev/null 2>&1
        then
            export LANG="en_US.iso88591"
            export LC_ADDRESS="en_US.iso88591"
            export LC_COLLATE="en_US.iso88591"
            export LC_CTYPE="en_US.iso88591"
            export LC_IDENTIFICATION="en_US.iso88591"
            export LC_MEASUREMENT="en_US.iso88591"
            export LC_MESSAGES="en_US.iso88591"
            export LC_MONETARY="en_US.iso88591"
            export LC_NAME="en_US.iso88591"
            export LC_NUMERIC="en_US.iso88591"
            export LC_PAPER="en_US.iso88591"
            export LC_TELEPHONE="en_US.iso88591"
            export LC_TIME="en_US.iso88591"
            export LC_ALL="en_US.iso88591"

            # From Sun Solaris
        elif locale -a | egrep '^en_GB.ISO8859-1$' > /dev/null 2>&1
        then
            export LANG="en_GB.ISO8859-1"
            export LC_ADDRESS="en_GB.ISO8859-1"
            export LC_COLLATE="en_GB.ISO8859-1"
            export LC_CTYPE="en_GB.ISO8859-1"
            export LC_IDENTIFICATION="en_GB.ISO8859-1"
            export LC_MEASUREMENT="en_GB.ISO8859-1"
            export LC_MESSAGES="en_GB.ISO8859-1"
            export LC_MONETARY="en_GB.ISO8859-1"
            export LC_NAME="en_GB.ISO8859-1"
            export LC_NUMERIC="en_GB.ISO8859-1"
            export LC_PAPER="en_GB.ISO8859-1"
            export LC_TELEPHONE="en_GB.ISO8859-1"
            export LC_TIME="en_GB.ISO8859-1"
            export LC_ALL="en_GB.ISO8859-1"

        elif locale -a | egrep '^en_US.ISO8859-1$' > /dev/null 2>&1
        then
            export LANG="en_US.ISO8859-1"
            export LC_ADDRESS="en_US.ISO8859-1"
            export LC_COLLATE="en_US.ISO8859-1"
            export LC_CTYPE="en_US.ISO8859-1"
            export LC_IDENTIFICATION="en_US.ISO8859-1"
            export LC_MEASUREMENT="en_US.ISO8859-1"
            export LC_MESSAGES="en_US.ISO8859-1"
            export LC_MONETARY="en_US.ISO8859-1"
            export LC_NAME="en_US.ISO8859-1"
            export LC_NUMERIC="en_US.ISO8859-1"
            export LC_PAPER="en_US.ISO8859-1"
            export LC_TELEPHONE="en_US.ISO8859-1"
            export LC_TIME="en_US.ISO8859-1"
            export LC_ALL="en_US.ISO8859-1"

            # From Debian and Sun Solaris
        elif locale -a | egrep '^en_GB$' > /dev/null 2>&1
        then
            export LANG="en_GB"
            export LC_ADDRESS="en_GB"
            export LC_COLLATE="en_GB"
            export LC_CTYPE="en_GB"
            export LC_IDENTIFICATION="en_GB"
            export LC_MEASUREMENT="en_GB"
            export LC_MESSAGES="en_GB"
            export LC_MONETARY="en_GB"
            export LC_NAME="en_GB"
            export LC_NUMERIC="en_GB"
            export LC_PAPER="en_GB"
            export LC_TELEPHONE="en_GB"
            export LC_TIME="en_GB"
            export LC_ALL="en_GB"

        elif locale -a | egrep '^en_US$' > /dev/null 2>&1
        then
            export LANG="en_US"
            export LC_ADDRESS="en_US"
            export LC_COLLATE="en_US"
            export LC_CTYPE="en_US"
            export LC_IDENTIFICATION="en_US"
            export LC_MEASUREMENT="en_US"
            export LC_MESSAGES="en_US"
            export LC_MONETARY="en_US"
            export LC_NAME="en_US"
            export LC_NUMERIC="en_US"
            export LC_PAPER="en_US"
            export LC_TELEPHONE="en_US"
            export LC_TIME="en_US"
            export LC_ALL="en_US"

        elif locale -a | egrep '^POSIX$' > /dev/null 2>&1
        then
            export LANG="POSIX"
            export LC_ADDRESS="POSIX"
            export LC_COLLATE="POSIX"
            export LC_CTYPE="POSIX"
            export LC_IDENTIFICATION="POSIX"
            export LC_MEASUREMENT="POSIX"
            export LC_MESSAGES="POSIX"
            export LC_MONETARY="POSIX"
            export LC_NAME="POSIX"
            export LC_NUMERIC="POSIX"
            export LC_PAPER="POSIX"
            export LC_TELEPHONE="POSIX"
            export LC_TIME="POSIX"
            export LC_ALL="POSIX"

        elif locale -a | egrep '^C$' > /dev/null 2>&1
        then
            export LANG="C"
            export LC_ADDRESS="C"
            export LC_COLLATE="C"
            export LC_CTYPE="C"
            export LC_IDENTIFICATION="C"
            export LC_MEASUREMENT="C"
            export LC_MESSAGES="C"
            export LC_MONETARY="C"
            export LC_NAME="C"
            export LC_NUMERIC="C"
            export LC_PAPER="C"
            export LC_TELEPHONE="C"
            export LC_TIME="C"
            export LC_ALL="C"

            # From Sun Solaris
        elif locale -a | egrep '^common$' > /dev/null 2>&1
        then
            export LANG="common"
            export LC_ADDRESS="common"
            export LC_COLLATE="common"
            export LC_CTYPE="common"
            export LC_IDENTIFICATION="common"
            export LC_MEASUREMENT="common"
            export LC_MESSAGES="common"
            export LC_MONETARY="common"
            export LC_NAME="common"
            export LC_NUMERIC="common"
            export LC_PAPER="common"
            export LC_TELEPHONE="common"
            export LC_TIME="common"
            export LC_ALL="common"

        fi
    else
        # locale -command not found. Let's use just POSIX.
        export LANG="POSIX"
        export LC_ADDRESS="POSIX"
        export LC_COLLATE="POSIX"
        export LC_CTYPE="POSIX"
        export LC_IDENTIFICATION="POSIX"
        export LC_MEASUREMENT="POSIX"
        export LC_MESSAGES="POSIX"
        export LC_MONETARY="POSIX"
        export LC_NAME="POSIX"
        export LC_NUMERIC="POSIX"
        export LC_PAPER="POSIX"
        export LC_TELEPHONE="POSIX"
        export LC_TIME="POSIX"
        export LC_ALL="POSIX"

    fi

    # Rewt do not use ispell E-Mail, Usenet News or IRC.
    unset MAIL MAILCHECK MAILPATH 2> /dev/null
    unset IRCNAME IRCSERVER IRCNICK 2> /dev/null
    unset NNTPSERVER 2> /dev/null
    unset SSH_AGENT_PID SSH_AUTH_SOCK 2> /dev/null
    unset hostnames mailpath 2> /dev/null
    unset DICTIONARY
fi

# }}}
# {{{ Some path manipulation: Add dirs from ${HOME} to the beginning.

pathmunge ${HOME}/bin
pathmunge ${HOME}/scripts

# }}}
# {{{ Rest of the path manipulation. Add some stuff to the end.

# In Debian GNU/Linux and other FHS-compliant Linux-distributions
# /usr/X11R6/bin and /usr/bin/X11 are just symlinks pointing to /usr/bin

if test -d /usr/X11R6/bin -a ! -h /usr/X11R6/bin
then
    pathmunge /usr/X11R6/bin after
fi

if test -d /usr/bin/X11 -a ! -h /usr/bin/X11
then
    pathmunge /usr/bin/X11 after
fi

pathmunge /opt/bin after

#################################################################
# I have installed almost everything from The Heirloom Project
# http://heirloom.sourceforge.net/

pathmunge ${HOME}/heirloom/5bin/posix2001 after
pathmunge ${HOME}/heirloom/5bin after
pathmunge /opt/heirloom/5bin/posix2001 after
pathmunge /opt/heirloom/5bin after

#################################################################
# I have installed all the stuff from AT&T ast-open
# http://www.research.att.com/~gsf/download/
# http://www.kornshell.com/
#


if test -x ${HOME}/ast/bin/package
then
    ATTASTOPENARCH="`${HOME}/ast/bin/package host`"
    pathmunge ${HOME}/ast/arch/${ATTASTOPENARCH}/bin after
    pathmunge ${HOME}/ast/arch/${ATTASTOPENARCH}/bin/ok after
    unset ATTASTOPENARCH
fi

pathmunge  ${HOME}/ast/bin after

if test -x /opt/ast/bin/package
then
    ATTASTOPENARCH="`/opt/ast/bin/package host`"
    pathmunge /opt/ast/arch/${ATTASTOPENARCH}/bin after
    pathmunge /opt/ast/arch/${ATTASTOPENARCH}/bin/ok after
    unset ATTASTOPENARCH
fi


pathmunge /opt/ast/bin after

#################################################################
# Some other stuff from The Heirloom Project

pathmunge ${HOME}/heirloom/5bin/posix after
pathmunge ${HOME}/heirloom/bin after
pathmunge ${HOME}/heirloom/ucb after
pathmunge ${HOME}/heirloom/5bin/s42 after
pathmunge ${HOME}/heirloom/ccs/bin after

pathmunge /opt/heirloom/5bin/posix after
pathmunge /opt/heirloom/bin after
pathmunge /opt/heirloom/ucb after
pathmunge /opt/heirloom/5bin/s42 after
pathmunge /opt/heirloom/ccs/bin after


#################################################################
# I installed everything from Plan 9 from User Space
# http://swtch.com/plan9port/
#

if test -x ${HOME}/plan9
then
    PLAN9="${HOME}/plan9"
    export PLAN9
    #PATH="${PATH}:${PLAN9}/bin"
    pathmunge ${PLAN9}/bin after
fi

if test -x /opt/plan9
then
    PLAN9="/opt/plan9"
    export PLAN9
    #PATH="${PATH}:${PLAN9}/bin"
    pathmunge ${PLAN9}/bin after
fi


# }}}
export PATH
# {{{ Interactive shells only

# This idea is from:
# man ash

case $- in *i*)
    # Add here all commands, that must be run under interactive shells only
    # (both login- and non-login)
    #echo "Interactive shell!"

    # vi-like keybindings

    #set -o vi 2> /dev/null

    # {{{ Environment variables for interactive shells only

    case `uname -s` in
        *SunOS*)
            stty -parenb -istrip cs8
            ;;

        *)
            stty pass8
    esac

    stty erase '^?'

    # Set $TERM for libvte terminals that set $TERM wrong (like gnome-terminal) 
    # This idea is from: http://vim.pastey.net/116135

    # gnome-terminal and other libvte-terminals claim that value of
    # environment variable TERM is ”xterm” although there exist
    # dedicated terminal types (for example ”gnome-256color”) for it.

    # gnome-terminal has non-standard environment variable COLORTERM
    # set to ”gnome-terminal”, but using it is not safe, if other
    # terminals are started from gnome-terminal.

    # Gnome developers are once again fscking idiots, because:

    # 1) It is not at all possible to configure that claimed terminal
    # type in settings of gnome-terminal. There is neither GUI-setting
    # nor gconf-key for that purpose.

    # 2) They refuse to fix that claimed terminal type and instead they
    # claim xterm emulation of gnome-terminal must be fixed.

    # 3) In spite of aforementioned things, they really haven’t fixed
    # xterm emulation and it has been in its unfixed state at least
    # for five fscking years.
    {
        [ "_$TERM" = "_xterm" ] && type ldd && type grep && type tput && [ -L "/proc/$PPID/exe" ] && {
        if ldd /proc/$PPID/exe | grep libvte; then
            if [ "`tput -Tgnome-256color colors`" = "256" ]; then
                TERM=gnome-256color
            elif [ "`tput -Txterm-256color colors`" = "256" ]; then
                TERM=xterm-256color
            elif tput -T gnome; then
                TERM=gnome
            fi
        fi
    } } >/dev/null 2>/dev/null

    export GIT_SHELL='/bin/zsh'

    if test "`$ID_BIN -u`" = "0"
    then
        export EDITOR='vim'
        #export EDITOR='ed'
        export VISUAL='vim'
        export GIT_EDITOR='vim'
    else
        # From man page of emacsclient of Emacs 23:
        # emacsclient -a, --alternate-editor=EDITOR
        # if the Emacs server is not running, run the specified editor
        # instead. This can also be specified via the  `ALTERNATE_EDITOR'
        # environment variable. If the value of EDITOR is the empty
        # string, then Emacs is started in daemon mode and emacsclient
        # will try to connect to it.
        export ALTERNATE_EDITOR='emacs'

        #export EDITOR='vim'
        export EDITOR='emacsclient -c -nw'
        #export EDITOR='ed'
        #export VISUAL='vim'
        export VISUAL='emacsclient -c -nw'

        #export GIT_EDITOR='vim'
        export GIT_EDITOR='emacsclient -c -nw'
        export GIT_RMAIL='mutt'
        export GIT_VMSTAT='vmstat'
        export GIT_PAGER='less'
        export GIT_BROWSER='lynx'
    fi

    if test "`$ID_BIN -u`" = "0"
    then
        export EDITOR='vim'
        export VISUAL='vim'
    fi

    export MANPAGER="less"
    export PAGER="less"
    export MANLESS="-i -M -R -W -x8 --shift=8 -X -F"

    # Midnight Commander
    # http://www.midnight-commander.org/

    if type mc > /dev/null 2>&1
    then
        if type vimless > /dev/null 2>&1
        then
            export VIEWER="vimless"
        fi

        # Use subshell support, if possible:
        if mc -V | grep 'With subshell support as default' > /dev/null 2>&1
        then
            export MYMCOPTS="-U"
        else
            export MYMCOPTS="-u"
        fi

        # Note! You may specify terminals that always force color mode
        # by adding the color_terminals variable to the Colors section
        # of the initialization file of Midnight Commander. But it
        # seems, it do not support wildcards.

        # Use color support, if possible:
        case "$TERM" in
            *color*|*linux*|*putty*|*rxvt*|*screen*|*xterm*)
                export MYMCOPTS="${MYMCOPTS} -c"
        esac

        # Use XTerm support if possible:
        case "$TERM" in
            *xterm*|*rxvt*)
                export MYMCOPTS="${MYMCOPTS} -x"
        esac

        # Use juhtolv-skin, if possible:
        # (Linux virtual console do not support double-lines of
        # juhtolv-skin in most cases)
        case "$TERM" in
            *linux*)
                export MC_SKIN="default"
                export MYMCOPTS="${MYMCOPTS} -S default"
                ;;
            *)
                export MC_SKIN="juhtolv"
                export MYMCOPTS="${MYMCOPTS} -S juhtolv"
        esac
        # And now create alias
        alias mc='mc ${MYMCOPTS}'
    fi


    #####################################
    # http://www.catb.org/~esr/BROWSER/
    #
    #export BROWSER="galeon -n %s:lynx %s"
    #export BROWSER="netscape -raise -remote \"openURL(%s,new-window)\":lynx"
    #export BROWSER="mozilla-firefox -remote \"openURL (%s,new-tab)\":lynx %s"
    export BROWSER="firefox %s:lynx %s"


    #####################################
    # LESS

    export LESSCHARSET="utf-8"

    #eval `lessfile`
    #LESSOPEN="|lesspipe.sh %s"
    #export LESSOPEN
    #eval `lesspipe.sh`

    if test -x ${HOME}/scripts/lesspipe.sh > /dev/null 2>&1
    then
        LESSOPEN="|${HOME}/scripts/lesspipe.sh %s"
        export LESSOPEN
        LESS_ADVANCED_PREPROCESSOR="true"
        export LESS_ADVANCED_PREPROCESSOR
    elif test -x ${HOME}/bin/lesspipe.sh > /dev/null 2>&1
    then
        LESSOPEN="|${HOME}/bin/lesspipe.sh %s"
        export LESSOPEN
        LESS_ADVANCED_PREPROCESSOR="true"
        export LESS_ADVANCED_PREPROCESSOR
    elif test -x /usr/local/scripts/lesspipe.sh > /dev/null 2>&1
    then
        LESSOPEN="|/usr/local/scripts/lesspipe.sh %s"
        export LESSOPEN
        LESS_ADVANCED_PREPROCESSOR="true"
        export LESS_ADVANCED_PREPROCESSOR
    elif test -x /usr/local/bin/lesspipe.sh > /dev/null 2>&1
    then
        LESSOPEN="|/usr/local/bin/lesspipe.sh %s"
        export LESSOPEN
        LESS_ADVANCED_PREPROCESSOR="true"
        export LESS_ADVANCED_PREPROCESSOR
    elif type lesspipe.sh > /dev/null 2>&1
    then
        LESSOPEN="|lesspipe.sh %s"
        export LESSOPEN
        LESS_ADVANCED_PREPROCESSOR="true"
        export LESS_ADVANCED_PREPROCESSOR
    elif type lessfile > /dev/null 2>&1
    then
        eval `lessfile`
    elif type lesspipe > /dev/null 2>&1
    then 
        eval `lesspipe`
    fi

    if test "`$ID_BIN -u`" = "0"
    then
        export LESSSECURE="1"
    else
        unset LESSSECURE 2> /dev/null
    fi

    lessenvupdate()
    {
        if type resize > /dev/null 2>&1
        then
            eval `resize`
        fi
        #if test "$COLUMNS" -gt 85
        if test "$COLUMNS" -gt 90
        then
            export LESS="-i -M -R -W -x8 --shift=8 -X -F -J -N"
        else
            export LESS="-i -M -R -W -x8 --shift=8 -X -F"
        fi
    }

    lessenvupdate

    export LESSHISTSIZE="1000"

    # S-Lang
    export COLORFGBG="lightgray;black"

    # Lynx
    if test -f "${HOME}/.lynxrc"
    then
        export LYNX_CFG="${HOME}/.lynxrc"
    fi

    # vshnu
    # http://www.cs.indiana.edu/~kinzler/vshnu/
    export VSHNUTMP="${HOME}/.vshnu_tmp"

    # }}}
    # {{{ Aliases for interactive shells only

    # I don't understand, why I would like to use aliases in other than
    # interactive shells.
    # {{{ Really important aliases

    alias which="type -path"
    alias lo="logout"
    # alias emacs="xemacs"

    alias cd-='cd -'

    alias cd..='cd ..'
    alias cd...='cd ../..'
    alias cd....='cd ../../..'
    alias cd.....='cd ../../../..'
    alias cd......='cd ../../../../..'
    alias cd.......='cd ../../../../../..'

    alias ..='cd ..'
    alias ...='cd ../..'
    alias ....='cd ../../..'
    alias .....='cd ../../../..'
    alias ......='cd ../../../../..'
    alias .......='cd ../../../../../..'

    # Sun Solaris has gazillion GNU utils, that has g added in the
    # beginning of their names. I try to (ab)use them,

    if ggrep --help 2>&1 | grep -i "gnu.org" > /dev/null 2>&1
    then
        if ggrep --help 2>&1 | grep -- '--color' > /dev/null 2>&1
        then
            GREP_OPTIONS="--color=auto"
            export GREP_OPTIONS
        else
            GREP_OPTIONS=""
            export GREP_OPTIONS
        fi
        alias grep='ggrep $GREP_OPTIONS'
        #alias egrep='gegrep $GREP_OPTIONS'
        alias egrep='ggrep $GREP_OPTIONS -E'
        #alias fgrep='gfgrep $GREP_OPTIONS -F'
        alias fgrep='ggrep $GREP_OPTIONS -F'
    elif grep --help 2>&1 | grep -- '--color' > /dev/null 2>&1
    then
        GREP_OPTIONS="--color=auto"
        export GREP_OPTIONS
        alias grep='grep $GREP_OPTIONS'
        alias egrep='egrep $GREP_OPTIONS'
        alias fgrep='fgrep $GREP_OPTIONS'
    fi

    if gls --help 2>&1 | grep -i "gnu.org" > /dev/null 2>&1
    then
        eval `gdircolors ~/.dircolors 2> /dev/null ` 
        LS_OPTIONS='-F --color=auto'
        export LS_OPTIONS
        alias ls='gls $LS_OPTIONS'
        alias ll='gls $LS_OPTIONS -l'
        alias l='gls $LS_OPTIONS -lA'
        alias l.='gls -d $LS_OPTIONS .[0-9a-zA-Z]*'
    elif gnuls --help 2>&1 | grep -i "gnu.org" > /dev/null 2>&1
    then
        eval `gdircolors ~/.dircolors 2> /dev/null ` 
        LS_OPTIONS='-F --color=auto'
        export LS_OPTIONS
        alias ls='gnuls $LS_OPTIONS'
        alias ll='gnuls $LS_OPTIONS -l'
        alias l='gnuls $LS_OPTIONS -lA'
        alias l.='gnuls -d $LS_OPTIONS .[0-9a-zA-Z]*'
    elif ls --help 2>&1 | grep "gnu.org" > /dev/null 2>&1
    then
        eval `dircolors ~/.dircolors 2> /dev/null ` 
        LS_OPTIONS='-F --color=auto'
        export LS_OPTIONS
        alias ls='ls $LS_OPTIONS'
        alias ll='ls $LS_OPTIONS -l'
        alias l='ls $LS_OPTIONS -lA'
        alias l.='ls -d $LS_OPTIONS .[0-9a-zA-Z]*'
    else
        LS_OPTIONS=""
        export LS_OPTIONS
        alias ls='ls $LS_OPTIONS'
        alias ll='ls $LS_OPTIONS -l'
        alias l='ls $LS_OPTIONS -lA'
        alias l.='ls -d $LS_OPTIONS .[0-9a-zA-Z]*'
    fi

    export TREE_CHARSET="UTF-8"
    alias tree='tree -F --dirsfirst -C'

    # AFAIK star is faster and better than GNU tar
    # http://cdrecord.berlios.de/old/private/star.html
    # ftp://ftp.berlios.de/pub/star/
    if star --version 2>&1 | grep -i "Schilling" > /dev/null 2>&1
    then
        alias tar='star'
    elif gtar --help 2>&1 | grep -i "gnu.org" > /dev/null 2>&1
    then
        alias tar="gtar"
    else
        unalias tar 2> /dev/null
    fi


    # Some more alias to avoid making mistakes:

    # I must disable this, because this software has a name clash with gcp of
    # Sun Solaris:
    # http://wiki.goffi.org/wiki/Gcp/en
    #if gcp --help 2>&1 | grep -i "gnu.org" > /dev/null 2>&1
    #then
    #    alias cp='gcp -i -p'
    #else
    #    alias cp='cp -i -p'
    #fi

    # Meanwhile, let's stick with this:
    alias cp='cp -i -p'


    if gmkdir --help 2>&1 | grep -i "gnu.org" > /dev/null 2>&1
    then
        alias mkdir='gmkdir --parents'
        alias md='gmkdir --parents'
    elif mkdir --help 2>&1 | grep -i "gnu.org" > /dev/null 2>&1
    then
        alias mkdir='mkdir --parents'
        alias md='mkdir --parents'
        #else
        #    alias mkdir='mkdir -p'
        #    alias md='mkdir -p'
    fi

    if gmv --help 2>&1 | grep -i "gnu.org" > /dev/null 2>&1
    then
        alias mv='gmv -i'
    else
        alias mv='mv -i'
    fi

    if grm --help 2>&1 | grep -i "gnu.org" > /dev/null 2>&1
    then
        alias rm='grm -i'
    else
        alias rm='rm -i'
    fi

    if gtail --help 2>&1 | grep -i "gnu.org" > /dev/null 2>&1
    then
        alias tail='gtail'
    fi

    # }}}
    # {{{ Misc aliases

    #alias myxlock='xlock -mode marquee -messagefont "-adobe-palatino-medium-r-normal-*-*-260-*-*-*-*-iso8859-1" -messagesfile ~/.xscreensaver.dir/myfortune.txt'

    #alias v1='export TERM="vt100"'
    #alias v2='export TERM="vt220"'
    #alias vx='export TERM="xterm-color"'

    #alias mylcdproc='/usr/bin/lcdproc C G T O M X -l curses'

    # "VT monitors all"

    # This is for my Digital VT-series text terminals
    # http://www.devolution.com/~slouken/projects/splitvt/
    # NOTE! ALWAYS USE THE LATEST VERSION OF splitvt!
    # OLDER VERSIONS HAS HAD SECURITY HOLES AND VULNERABILITIES!
    # http://lcdproc.omnipotent.net/
    # http://slmon.sourceforge.net/

    #alias vtmall='splitvt -s 4 -upper "/usr/sbin/lcdproc C G M X -l curses" -lower "slmon" '

    # LATEST VERSIONS OF LCDPROC HAS BEEN REDESIGNED SO THAT AFOREMENTIONED ALIASES
    # mylcdproc and vtmall DO NOT WORK ANYMORE. I AM CONFUSED. MEANWHILE USE
    # othermon AND yamon.

    # If terminal shows some linedrawing chars or is otherwise messed:
    # http://www.in-ulm.de/~mascheck/various/alternate_charset/
    alias kscreen='echo -ne "\017"'
    #alias vtn='echo "X[mX(BX)0OX[?5lX7X[rX8" | tr "XO" "\033\017"'
    alias vtn='echo "X[4iX[?4iX[?38lX\X(BX)0OX[?5lX[0mX[rX[HX[J" | tr "XO" "\033\017"'

    # Open file to already running Emacs 23 (or later version) and get
    # back to shell prompt. If no filename is said, open new graphical
    # frame.
    # NOTE!: This alias may be dangerous: in QWERTY-keyboards e-key is
    # close to r-key, so you may accidentally type “rm” instead of
    # “em”. You’d better have rm-command aliased to something safe,
    # for example “rm -i”. Actually I already have such alias in this
    # config.
    #alias em='emacsclient -n'
    alias em='unset XMODIFIERS ; emacsclient -n'

    # Open file to already running Emacs 23 (or later) and open new
    # frame of it in text mode:
    alias e='emacsclient -c -nw'

    # Tell Emacs-server to quit:
    alias killemacs="emacsclient -e '(kill-emacs)'"


    alias ncal='ncal -M -w'
    alias ccal='ccal -e'


    # Use both ionice and nice easily:
    if test -x /usr/bin/ionice -a -x /usr/bin/nice
    then
        alias verynice='/usr/bin/nice -n 19 /usr/bin/ionice -c2 -n7'
    fi

    # }}}
    # }}}
    # {{{ Functions for interactive shells only

    # I really do not understand, why I would use these functions
    # under non-interactive shells

    # {{{ cp, cd, mkdir, mv, ls etc. very fast

    cdls ()
    {
        # go to directory and say "ls"
        if test "$#" != "1"
        then
            echo "$SHELL : cdls : Wrong number of arguments"
            return 1
        fi
        cd "$1" && ls $LS_OPTIONS
    }

    cpcd ()
    {
        # copy files to directory and go there
        # Corresponding trick under tcsh:
        # alias cpcd 'cp \!*;cd \!$'
        cp "$@" && eval LAST_DIR="\${$#}" && cd $LAST_DIR
        unset LAST_DIR
    }

    mvcd ()
    {
        # move files to directory and go there
        mv "$@" && eval LAST_DIR="\${$#}" && cd $LAST_DIR
        unset LAST_DIR
    }

    mdcd ()
    {
        # make directory and go there
        #mkdir "$@" && { shift $(( $#-1 )) ; cd "$1"; }
        mkdir "$@" && eval LAST_DIR="\${$#}" && cd $LAST_DIR
        unset LAST_DIR
    }

    mdmv ()
    {
        # make directory and move stuff there
        # usage: mdmv (newdir) (stuff)
        #mkdir -p "$1" && mv $2 $1
        mkdir "$1" && DIR="$1" && shift && mv "$@" "$DIR"
        unset DIR
    }

    mdmvcd ()
    {
        # make directory, move stuff there, and go there
        # usage: mdmvcd (newdir) (stuff)
        mkdir "$1" && DIR="$1" && shift && mv "$@" "$DIR" && cd $DIR
        unset DIR
    }

    mdcp ()
    {
        # make directory and copy stuff there
        # usage: mdxp (newdir) (stuff)
        mkdir "$1" && DIR="$1" && shift && cp "$@" $DIR
        unset DIR
    }

    mdcpcd ()
    {
        # make directory, copy stuff there, and go there
        # usage: mdcpcd (newdir) (stuff)
        mkdir "$1" && DIR="$1" && shift && cp "$@" $DIR && cd $DIR
        unset DIR
    }

    cddoc ()
    {
        if test -z "$1"
        then
            return 1
        fi

        if test -d /usr/share/doc/$1
        then
            cd /usr/share/doc/$1
        elif test -d /usr/doc/$1
        then
            cd /usr/doc/$1
        else
            return 1
        fi
    }

    # }}}
    # {{{ Mounting of CD-ROM etc.

    mountcd ()
    {
        # mount directory and go there
        if test "$1" = "" -o "$#" = "0"
        then
            #MOUNTCDDIR="/mnt/cdrom"
            MOUNTCDDIR="/media/cdrom"
        else
            MOUNTCDDIR="$1"
        fi
        mount -v "$MOUNTCDDIR" && cd "$MOUNTCDDIR"
    }

    umountcd ()
    {
        if test "$1" = "" -o "$#" = "0"
        then
            #UMOUNTCDDIR="/mnt/cdrom"
            UMOUNTCDDIR="/media/cdrom"
        else
            UMOUNTCDDIR="$1"
        fi

        if pwd | grep $UMOUNTCDDIR > /dev/null 2>&1
        then
            cd
        fi
        umount -v $UMOUNTCDDIR && \
            if echo $UMOUNTCDDIR | grep -E '.*cdrom.*|.*dvd.*' > /dev/null 2>&1
            then
                sleep 1 && eject "$UMOUNTCDDIR"
            fi
        }

        # }}}
        # {{{ NCD clones (they rules!)

        # WCD
        # http://wcd.sourceforge.net/
        # http://www.xs4all.nl/~waterlan/

        wcd ()
        {
            wcd.exe $*
            . $HOME/bin/wcd.go
        }

        # KCD
        # http://kcd.sourceforge.net/

        if test -f /etc/kcd.sh.init
        then
            . /etc/kcd.sh.init
        fi

        # }}}
        # {{{ Misc functions
        newsmsg()
        {
            # This is from IRC-channel #linux.fi.
            # It was invented and added to dictionary of a bot called "mv"
            # by a person who prefer to remain anonymous.
            echo -n "Message-ID: "
            read MESSAGEID
            printf "article $MESSAGEID\nquit\n" | nc $NNTPSERVER nntp | less
            unset MESSAGEID
        }

        loadallshrc ()
        {
            . "/etc/profile"
            . "${HOME}/.profile"
            . "${HOME}/.shinit.sh"
        }

        # http://www.vim.org/tips/tip.php?tip_id=167
        #vman ()
        #{
        #    /usr/bin/man $* | col -bp | iconv -c | view -c 'set ft=man nomod nolist' -
        #}

        # }}}
        # }}}
        # {{{ ctheme
        # http://www.sourceforge.net/projects/ctheme/

        case $TERM in *linux*|*putty*)
            if type ctheme > /dev/null 2>&1
            then
                CTHEME="xterm16.ct"

                OLDPATH="$PATH"
                PATH="/usr/local/share/cthemes:/usr/share/cthemes:$PATH"
                $CTHEME
                PATH="$OLDPATH"
                export PATH
                unset CTHEME
            fi
    esac

    # }}}

    #cd $HOME
    # End stuff for interactive-shells only

    ###################################
    # gcal
    #

    GCAL='--iso-week-number=yes --with-week-number --starting-day=Monday --type=standard'
    export GCAL

esac

# }}}

